import { IDomEditor } from '@wangeditor/editor'
import { editorRef, treeData, xmlContent, xmlDOM } from '../constants'
import { TreeOption } from 'naive-ui'
import { nodeSet } from '../constants/nodeParsed'
import { getCurrentInstance, getCurrentScope } from 'vue'

export const handleEditor = (editor: IDomEditor) => {
    // console.log(editor.getElemsByTypePrefix('JOBCARD'))
    // console.log(editor)
    // const headers = editor.getElemsByTypePrefix('header')
    // const menu = headers.map((header: any) => {
    //     const title = SlateNode.string(header)
    //     return {
    //         title,
    //         key: header.id,
    //         type: header.type
    //     }
    // })
    // treeData.value = buildTree(menu)
}

let lastFocusedId = ''
export const nodeProps = ({ option }: { option: TreeOption }) => {
    return {
        onClick() {
            editorRef.value?.editorRef.scrollToElem([option.key])
            let container = editorRef.value?.editorRef?.getEditableContainer()
            if (container) {
                if (lastFocusedId) {
                    container.querySelector(`#${lastFocusedId}`)?.classList.remove('focus')
                }
                lastFocusedId = option.key as string
                container.querySelector(`#${lastFocusedId}`)?.classList.add('focus')
            }
        }
    }
}
export const uploadXml = async (file: File) => {
    const xmlProcessing = useXMLProcessing()
    const res = await xmlProcessing.processFile(file, nodeSet)
    treeData.value = res.treeData
    xmlDOM.value = res.xmlDOM
    xmlContent.value = res.xmlContent
    editorRef.value?.editorRef?.setHtml(xmlContent.value)
}
